<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use App\Models\VideoGame;

class VideoGameController extends Controller
{
    /**
	 * Show the formpassword page
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function gamelist( Request $request )
	{
		$jeu = VideoGame::all();	
		return view('gamelist')
			->with('jeux',$jeu)
			->with('user',$request->session()->get('user'))
			->with('message',$request->session()->get('message'));
    }

    /**
	 * Show the formpassword page
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function formgame( Request $request )
	{
		return view('formgame')
			->with('user',$request->session()->get('user'))
			->with('message',$request->session()->get('message'));
	}

    /**
	 * Add a game
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function addGame( Request $request )
	{
		//On sécurise les variables

        try
        {
            $jeu = new VideoGame;
            $jeu->nom = $request->nom;
            $jeu->proprietaire = $request->session()->get('user')->user_id;
            $jeu->url = $request->url;
            $jeu->description = $request->description;

            $jeu->save();

            $request->session()->put('message',"Jeu créé");
            return redirect()->route('gamelist');
        }
		catch(QueryException $e)
        {
            $request->session()->put('message',$e->getMessage());
            return redirect()->route('formgame');
        }

		return redirect()->route('gamelist')->with('message','Game created !');		
	}

	/**
	 * Edit an article
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @param  int $article_id
	 * @return \Illuminate\Http\Response
	 */
	public function deletegame( Request $request, int $jeu_id )
	{
		try
		{
			VideoGame::where('id', $jeu_id)->delete();
		}
		catch (\Illuminate\Database\QueryException $e)
		{
			return redirect()->route('gamelist')
				->with('message','Sorry, an error occur durng article saving. Please try again.');
		}

		return redirect()->route('gamelist')->with('message','Game deleted!');
	}
}
