<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use App\Models\Bird;
use App\Models\UserEloquent;

class BirdController extends Controller
{
    /**
	 * Show new bird page
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function formBird( Request $request )
	{
		return view('formBird')
			->with('user',$request->session()->get('user'))
			->with('message',$request->session()->get('message'));
    }

    /**
	 * Show bird listpage
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function birdList( Request $request )
	{
        $birds = Bird::all();
        return view('birdList')
            ->with('birds',$birds)
			->with('user',$request->session()->get('user'))
			->with('message',$request->session()->get('message'));
    }

    /**
	 * Show details birds
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function detailsBird( Request $request , int $bird_id)
	{
        return view('formdetails')
            ->with('birds', Bird::find($bird_id))
			->with('user',$request->session()->get('user'))
			->with('message',$request->session()->get('message'));
	}

    /**
	 * Show details birds
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function birdfromplace( Request $request )
	{
		return view('birdfromplace')
			->with('birds',Bird::all())	
			->with('user',$request->session()->get('user'))
			->with('message',$request->session()->get('message'));
	}
	
	/**
	 * Show find birds
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function findbird( Request $request , int $bird_id)
	{
		return view('birdfromplace')
			//->with('birds',Bird::all())	
			//->with('birds', Bird::find($bird_id))
			->with('bird',$request->session()->get('bird'))
			->with('user',$request->session()->get('user'))
			->with('message',$request->session()->get('message'));
    }

    /**
	 * delete bird
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @param  int $article_id
	 * @return \Illuminate\Http\Response
	 */
	public function deletebird( Request $request, int $bird_id )
	{
		try
		{
			Bird::where('ornithologue', $bird_id)->delete();
		}
		catch (\Illuminate\Database\QueryException $e)
		{
			return redirect()->route('birdList')
				->with('message','Sorry, an error occur durng articledeleteing. Please try again.');
		}

		return redirect()->route('birdList')->with('message','Bird deleted!');
	}
    
    /**
	 * Add a bird
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function addBird( Request $request )
	{
		if ( !$request->filled(['place','species','scientific', 'description']) )
			return redirect()->route('formBird')->with('message','Some POST data are missing.');

		$bird = new Bird;
        $bird->ornithologue = $request->session()->get('user')->user_id;

        $bird->date_observ=now();
        $bird->lieu_obser=$request->place;

		$bird->espece=$request->species;
        $bird->nom_science=$request->scientific;
        $bird->description=$request->description;

		try
		{
			$bird->save();
		}
		catch (\Illuminate\Database\QueryException $e)
		{
			return redirect()->route('formBird')
				->with('message','Sorry, the bird cannot be created');
		}

		return redirect()->route('account')->with('message','Bird created!');
	}
}
