<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\BirdController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

/* ------------------------------------------------------------------------
| Public routing */
Route::get('/', [UserController::class,'signin']);
Route::post('adduser', [UserController::class,'addUser'])->name('adduser');
Route::post('authenticate', [UserController::class,'authenticate'])->name('authenticate');
Route::get('signin', [UserController::class,'signin'])->name('signin');
Route::get('signup', [UserController::class,'signup'])->name('signup');
// ------------------------------------------------------------------------

/* ------------------------------------------------------------------------
| Admin routing */
Route::prefix('admin')->middleware('auth.myuser')->group( function() {

	Route::post('changepassword', [UserController::class,'changePassword'])->name('changepassword');
	Route::get('deleteuser', [UserController::class,'deleteUser'])->name('deleteuser');
	Route::get('formpassword', [UserController::class,'formpassword'])->name('formpassword');
	Route::get('account', [UserController::class,'account'])->name('account');
	Route::get('signout', [UserController::class,'signout'])->name('signout');

	Route::get('myprofile', [UserController::class,'myprofile'])->name('myprofile');
	Route::get('formBird', [BirdController::class,'formBird'])->name('formBird');
	Route::post('addBird', [BirdController::class,'addBird'])->name('addBird');

	Route::get('birdList', [BirdController::class,'birdList'])->name('birdList');

	Route::post('detailsBird/{bird_id}', [BirdController::class,'detailsBird'])->name('detailsBird');
	Route::post('deletebird/{bird_id}', [BirdController::class,'deletebird'])->name('deletebird');

	Route::get('birdfromplace', [BirdController::class,'birdfromplace'])->name('birdfromplace');

	Route::get('findbird/{bird_id}', [BirdController::class,'findbird'])->name('findbird');
});
// ------------------------------------------------------------------------
